#include "LPC11xx.h"
#include "7seg.h"

static int ledbuf[4] = {-1, -1, -1, -1};
const int digits[10] = {0x3f, 0x06, 0x5b, 0x4f, 0x66, 0x6d, 0x7d, 0x07, 0x7f, 0x6f};

void leddisp () {
    static int n = 0;
    int i, bit;

    // led off
   	LPC_GPIO0->DATA |= (1<<9)|(1<<8)|(1<<6)|(1<<5)|(1<<4)|(1<<3)|(1<<2)|(1<<1); // k off
	LPC_GPIO1->DATA |= (1<<9)|(1<<8)|(1<<4)|(1<<2); // common off

    n ++;
    if (n >= 4) n = 0;

    // led on
    if (ledbuf[n] >= 0) {
        bit = 1;
        for (i = 0; i < 7; i ++) {
        	if (digits[ledbuf[n] & 0x7f] & bit) {
        		switch (i) {
        		case 0: LPC_GPIO0->DATA &= ~(1<<1); break;
        		case 1: LPC_GPIO0->DATA &= ~(1<<2); break;
        		case 2: LPC_GPIO0->DATA &= ~(1<<3); break;
        		case 3: LPC_GPIO0->DATA &= ~(1<<4); break;
        		case 4: LPC_GPIO0->DATA &= ~(1<<5); break;
        		case 5: LPC_GPIO0->DATA &= ~(1<<6); break;
        		case 6: LPC_GPIO0->DATA &= ~(1<<8); break;
        		}
        	}
            bit = bit << 1;
        }
        if (ledbuf[n] & 0x80) {
        	LPC_GPIO0->DATA &= ~(1<<9);
        }
    }

	switch (n) {
	case 0: LPC_GPIO1->DATA &= ~(1<<2); break;
	case 1: LPC_GPIO1->DATA &= ~(1<<4); break;
	case 2: LPC_GPIO1->DATA &= ~(1<<8); break;
	case 3: LPC_GPIO1->DATA &= ~(1<<9); break;
	}
}

void writeled (int num, int dot, int mask, int zero) {
    if (((num >= 1000) || (zero & 0x08)) && (mask & 0x08)) {
        ledbuf[0] = num / 1000 % 10;
    } else {
        ledbuf[0] = -1;
    }
    if (((num >= 100) || (zero & 0x04)) && (mask & 0x04)) {
        ledbuf[1] = (num / 100) % 10;
    } else {
        ledbuf[1] = -1;
    }
    if (((num >= 10) || (zero & 0x02)) && (mask & 0x02)) {
        ledbuf[2] = (num / 10) % 10;
    } else {
        ledbuf[2] = -1;
    }
    if (mask & 0x01) {
        ledbuf[3] = num % 10;
    } else {
        ledbuf[3] = -1;
    }

    if (dot >= 1 && dot <= 4) {
        ledbuf[dot - 1] |= 0x80;
    }
}

void initled () {

	LPC_SYSCON->SYSAHBCLKCTRL |= (1<<6);

	LPC_GPIO0->DIR |= (1<<9)|(1<<8)|(1<<6)|(1<<5)|(1<<4)|(1<<3)|(1<<2)|(1<<1);
   	LPC_GPIO0->DATA |= (1<<9)|(1<<8)|(1<<6)|(1<<5)|(1<<4)|(1<<3)|(1<<2)|(1<<1); // k off

	LPC_GPIO1->DIR |= (1<<9)|(1<<8)|(1<<4)|(1<<2);
   	LPC_GPIO1->DATA |= (1<<9)|(1<<8)|(1<<4)|(1<<2); // common off
   	LPC_IOCON->R_PIO1_2 |= 0x01;
}
